/*
    Copyright (C) 2012 Bartosz Broda, Jacek Bochenek, Łukasz Biłeńkij, 
    Damian Jaworski, Wojciech Mazur, Dominik Piasecki, Maciej Piasecki, 
    Radosław Ramocki
    
    This program is free software; you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as published by the Free
Software Foundation; either version 3 of the License, or (at your option)
any later version.

    This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. 

    See the LICENSE and COPYING files for more details.
*/

#include "../comparator_stdheaders.h"
#include "EuclidianDist.h"

namespace smartcomparator
{
	namespace distances
	{
		EuclidianDist::EuclidianDist(Matrices::SuperMatrixPtr m)
			: DistanceFunction(m)
		{
		}

		EuclidianDist::~EuclidianDist(void)
		{
		}

		double EuclidianDist::CountDistance(Matrices::CompressedVector& v1, Matrices::CompressedVector& v2,
			size_t , size_t , const std::set<size_t> &v1Ind, const std::set<size_t> &v2Ind)
		{
			double dist = 0;
			std::set<size_t> filteredIndices;

			DistanceFunction::SetUnion(v1,v2, v1Ind,v2Ind, filteredIndices);

			for(std::set<size_t>::const_iterator iter = filteredIndices.begin(); iter != filteredIndices.end();iter++)
			{
				double v1Val = (v1)[(*iter)];
				double v2Val = (v2)[(*iter)];
				dist += (v1Val-v2Val)*(v1Val-v2Val);
			}

			return sqrt(dist);
		}


		double EuclidianDist::MinValue() const
		{
			return 0;
		}


		double EuclidianDist::CountDistance(Matrices::CompressedVector& v1, Matrices::CompressedVector& v2,
			const std::set<size_t> &v1Ind, const std::set<size_t> &v2Ind)
		{
			return CountDistance(v1,v2,-1,-1, v1Ind, v2Ind);
		}

	}
}
